JUCE: MemoryInputStream Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
MemoryInputStream Class Reference
juce_core » streams

Allows a block of data to be accessed as a stream. More...

`#include <juce_MemoryInputStream.h>`

Inheritance diagram for MemoryInputStream:

## Public Member Functions
| MemoryInputStream (const void *sourceData, size_t sourceDataSize, bool keepInternalCopyOfData)
| Creates a MemoryInputStream.
| MemoryInputStream (const MemoryBlock &data, bool keepInternalCopyOfData)
| Creates a MemoryInputStream.
| MemoryInputStream (MemoryBlock &&blockToTake)
| Creates a stream by moving from a MemoryBlock.
| ~MemoryInputStream () override
| Destructor.
const void * | getData () const noexcept
| Returns a pointer to the source data block from which this stream is reading.
size_t | getDataSize () const noexcept
| Returns the number of bytes of source data in the block from which this stream is reading.
int64 | getPosition () override
| Returns the offset of the next byte that will be read from the stream.
bool | setPosition (int64) override
| Tries to move the current read position of the stream.
int64 | getTotalLength () override
| Returns the total number of bytes available for reading in this stream.
bool | isExhausted () override
| Returns true if the stream has no more data to read.
int | read (void *destBuffer, int maxBytesToRead) override
| Reads some data from the stream into a memory buffer.
void | skipNextBytes (int64 numBytesToSkip) override
| Reads and discards a number of bytes from the stream.
Public Member Functions inherited from InputStream
virtual | ~InputStream ()=default
| Destructor.
int64 | getNumBytesRemaining ()
| Returns the number of bytes available for reading, or a negative value if the remaining length is not known.
ssize_t | read (void *destBuffer, size_t maxBytesToRead)
virtual char | readByte ()
| Reads a byte from the stream.
virtual bool | readBool ()
| Reads a boolean from the stream.
virtual short | readShort ()
| Reads two bytes from the stream as a little-endian 16-bit value.
virtual short | readShortBigEndian ()
| Reads two bytes from the stream as a little-endian 16-bit value.
virtual int | readInt ()
| Reads four bytes from the stream as a little-endian 32-bit value.
virtual int | readIntBigEndian ()
| Reads four bytes from the stream as a big-endian 32-bit value.
virtual int64 | readInt64 ()
| Reads eight bytes from the stream as a little-endian 64-bit value.
virtual int64 | readInt64BigEndian ()
| Reads eight bytes from the stream as a big-endian 64-bit value.
virtual float | readFloat ()
| Reads four bytes as a 32-bit floating point value.
virtual float | readFloatBigEndian ()
| Reads four bytes as a 32-bit floating point value.
virtual double | readDouble ()
| Reads eight bytes as a 64-bit floating point value.
virtual double | readDoubleBigEndian ()
| Reads eight bytes as a 64-bit floating point value.
virtual int | readCompressedInt ()
| Reads an encoded 32-bit number from the stream using a space-saving compressed format.
virtual String | readNextLine ()
| Reads a UTF-8 string from the stream, up to the next linefeed or carriage return.
virtual String | readString ()
| Reads a zero-terminated UTF-8 string from the stream.
virtual String | readEntireStreamAsString ()
| Tries to read the whole stream and turn it into a string.
virtual size_t | readIntoMemoryBlock (MemoryBlock &destBlock, ssize_t maxNumBytesToRead=-1)
| Reads from the stream and appends the data to a MemoryBlock.

## Additional Inherited Members
Protected Member Functions inherited from InputStream
| InputStream ()=default

## Detailed Description

Allows a block of data to be accessed as a stream.

This can either be used to refer to a shared block of memory, or can make its own internal copy of the data when the MemoryInputStream is created.

## Constructor & Destructor Documentation

## ◆ MemoryInputStream() [1/3]

MemoryInputStream::MemoryInputStream | ( | const void * | sourceData,
|  | size_t | sourceDataSize,
|  | bool | keepInternalCopyOfData
| ) |  |

Creates a MemoryInputStream.

Parameters

  sourceData | the block of data to use as the stream's source
  sourceDataSize | the number of bytes in the source data block
  keepInternalCopyOfData | if false, the stream will just keep a pointer to the source data, so this data shouldn't be changed for the lifetime of the stream; if this parameter is true, the stream will make its own copy of the data and use that.

## ◆ MemoryInputStream() [2/3]

MemoryInputStream::MemoryInputStream | ( | const MemoryBlock & | data,
|  | bool | keepInternalCopyOfData
| ) |  |

Creates a MemoryInputStream.

Parameters

  data | a block of data to use as the stream's source
  keepInternalCopyOfData | if false, the stream will just keep a reference to the source data, so this data shouldn't be changed for the lifetime of the stream; if this parameter is true, the stream will make its own copy of the data and use that.

## ◆ MemoryInputStream() [3/3]

MemoryInputStream::MemoryInputStream | ( | MemoryBlock && | blockToTake | ) |

Creates a stream by moving from a MemoryBlock.

## ◆ ~MemoryInputStream()

MemoryInputStream::~MemoryInputStream | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ getData()

const void * MemoryInputStream::getData | ( |  | ) | const
| noexcept

Returns a pointer to the source data block from which this stream is reading.

## ◆ getDataSize()

size_t MemoryInputStream::getDataSize | ( |  | ) | const
| noexcept

Returns the number of bytes of source data in the block from which this stream is reading.

## ◆ getPosition()

int64 MemoryInputStream::getPosition | ( |  | ) |
| overridevirtual

Returns the offset of the next byte that will be read from the stream.

See also
  setPosition

Implements InputStream.

## ◆ setPosition()

bool MemoryInputStream::setPosition | ( | int64 | newPosition | ) |
| overridevirtual

Tries to move the current read position of the stream.

The position is an absolute number of bytes from the stream's start.

Some streams might not be able to do this, in which case they should do nothing and return false. Others might be able to manage it by resetting themselves and skipping to the correct position, although this is obviously a bit slow.

Returns
  true if the stream manages to reposition itself correctly

See also
  getPosition

Implements InputStream.

## ◆ getTotalLength()

int64 MemoryInputStream::getTotalLength | ( |  | ) |
| overridevirtual

Returns the total number of bytes available for reading in this stream.

Note that this is the number of bytes available from the start of the stream, not from the current position.

If the size of the stream isn't actually known, this will return -1.

See also
  getNumBytesRemaining

Implements InputStream.

## ◆ isExhausted()

bool MemoryInputStream::isExhausted | ( |  | ) |
| overridevirtual

Returns true if the stream has no more data to read.

Implements InputStream.

## ◆ read()

int MemoryInputStream::read | ( | void * | destBuffer,
|  | int | maxBytesToRead
| ) |  |
| overridevirtual

Reads some data from the stream into a memory buffer.

This is the only read method that subclasses actually need to implement, as the InputStream base class implements the other read methods in terms of this one (although it's often more efficient for subclasses to implement them directly).

Parameters

  destBuffer | the destination buffer for the data. This must not be null.
  maxBytesToRead | the maximum number of bytes to read - make sure the memory block passed in is big enough to contain this many bytes. This value must not be negative.

Returns
  the actual number of bytes that were read, which may be less than maxBytesToRead if the stream is exhausted before it gets that far

Implements InputStream.

## ◆ skipNextBytes()

void MemoryInputStream::skipNextBytes | ( | int64 | numBytesToSkip | ) |
| overridevirtual

Reads and discards a number of bytes from the stream.

Some input streams might implement this more efficiently, but the base class will just keep reading data until the requisite number of bytes have been done. For large skips it may be quicker to call setPosition() with the required position.

Reimplemented from InputStream.

The documentation for this class was generated from the following file:

- juce_MemoryInputStream.h